// Messen der Spannung an Pin 1.5
// Steuerung eines Servos an Pin 1.2
// 2010-10-15: von jl erstellt

#include "servo01.h"
#include <intrinsics.h>
#include "io430.h"

void initialize()
{
  WDTCTL = WDTPW | WDTHOLD;
  
  BCSCTL1 = CALBC1_1MHZ;
  DCOCTL = CALDCO_1MHZ;

  ADC10CTL0 = ADC10SHT_2 | ADC10ON;
  ADC10CTL1 = INCH_5;
  ADC10AE0 = BIT5;
  ADC10CTL0 |= ENC;
  
  P1DIR |= BIT2;
  P1SEL |= BIT2;
  
  TACCTL1 = OUTMOD_7;
  TACTL = MC_2 | TASSEL_2 | TACLR;
  setServoTo(50);
}

unsigned int readAnalog()
{
  ADC10CTL0 |= ADC10SC;
  while ((ADC10CTL1 & ADC10BUSY) != 0)
  {}
  return ADC10MEM; 
}

void setServoTo(int percentage)
{
  TACCR1 = 10*percentage + 1000;  
}

void waitOneMillisecond()
{
  unsigned short tStart = TAR;
  unsigned short tEnd = tStart + 1000;
  // Workaround, weil TAR nur bis 0xFFFE zhlt
  if(tEnd == 0xFFFF)
  {
    tEnd--;
  }
  
  if(tEnd < tStart) // Hatten wir einen berlauf beim Berechnen von tEnd?
  {
    while(TAR > tEnd)
    {}
  }
  while(TAR < tEnd)
  {}    
}

void waitMilliseconds(unsigned int duration)
{
  for(unsigned int i = 0; i < duration; i++)
  {
    waitOneMillisecond();
  }
}